#!/usr/bin/env python
# show one trace from a file

import sys
import gzip
from ROOT import TCanvas, TGraph
from ROOT import gROOT
from array import array

# which trace to show (out of 1000)
Trace=1


# is it batch?
# if batch, set input to batch
myinput="no any input"
if (len(sys.argv) > 1):
   myinput = sys.argv[1]
print "Mode=",myinput

print 'Number of arguments:', len(sys.argv), 'arguments.'
print 'Argument List:', str(sys.argv)

if (len(sys.argv) <3):
   print "Pass file with calibrated traces and trace number (1-1000)!"
   sys.exit()

n=0
myPath=sys.argv[1]
Trace=int(sys.argv[2])

print "Read=",myPath
fileN=myPath
f=gzip.open(fileN, 'r')

gROOT.Reset()
c1 = TCanvas( 'c1', 'Trace Nr='+str(Trace), 200, 10, 700, 500 )
x, y = array( 'd' ), array( 'd' )

n=0
traces={}
n_trace=1
for l in f.readlines():
      l=l.replace("\n","")
      if (len(l)<5): continue
      if l.find("trace")>-1: 
                     traces[n_trace]=list
                     n_trace = n_trace+1
                     n=0
                     list=[]
                     # print "trace=",n_trace 
                     continue
      if l.find("#")>-1: continue
      xy=l.split()
      xx=float(xy[0])
      yy=float(xy[1])
      yy_cor=float(xy[2])
      list.append([xx,yy, yy_cor])
      n=n+1


# fill TGraph
lines=traces[Trace+2]
for h in lines:
     hhh=h
     xx=hhh[0]
     yy=hhh[1]
     yy_corr=hhh[2]
     x.append( xx )
     y.append( yy_corr )
f.close()   

gr = TGraph( n, x, y )
gr.SetLineColor( 2 )
gr.SetLineWidth( 2 )
gr.SetMarkerColor( 4 )
gr.SetMarkerSize( 0.5 )
gr.SetMarkerStyle( 20 )
gr.SetTitle( "Trace="+str(Trace) )
gr.GetXaxis().SetTitle( 'T [ns]' )
gr.GetYaxis().SetTitle( 'mV' )
gr.Draw( 'ACP' )

c1.Update()
if (myinput != "-b"):
              if (raw_input("Press any key to exit") != "-9999"):
                         c1.Close(); sys.exit(1);
 
 
